<?php
//
// Internal wpTuner diagnostic module
// This is only used if wpTuner Debug Level is enabled
//

function wpTuneDebug($wptObject) {
	global $user_level,$wp_version; // already pulled in by show code

	print '<br/><b>'.__('wpTuner Diagnostics','wptuner')."</b><br/>\n";
	print __('Debug level: ','wptuner').$wptObject->iDebugLevel."<br/>\n";
	print __('User level: ','wptuner').$user_level."<br/>\n";
	print __('WP version: ','wptuner').$wp_version."<br/>\n";
	print __('PHP version: ','wptuner').phpversion()."<br/>\n";
	print __('MySQL version: ','wptuner').mysql_get_server_info()."<br/>\n";
	print __('WP theme: ','wptuner').get_current_theme()."<br/>\n";
	if ($wptObject->iDebugLevel & 16) {
		print __('WP plugins: ','wptuner');
		$current_plugins = get_option('active_plugins');
		if ( is_array($current_plugins) ) {
			print implode(',',$current_plugins);
		}
		print "<br/>\n";
	}
	if ($wptObject->iDebugLevel & 32) {
		print __('wpTuner Object: ','wptuner');
		print '<pre>'.print_r($wptObject,TRUE).'</pre>';
		print "<br/>\n";
	}
	if ($wptObject->iDebugLevel & 64) {
		print __('PHP Info: ','wptuner');
		ob_start();
		phpinfo();
		
		preg_match ('%<style type="text/css">(.*?)</style>.*?<body>(.*?)</body>%s', ob_get_clean(), $matches);
		
		# $matches [1]; # Style information
		# $matches [2]; # Body information
		
		echo "<div class='phpinfodisplay'><style type='text/css'>\n",
		    join( "\n",
		        array_map(
		            create_function(
		                '$i',
		                'return ".phpinfodisplay " . preg_replace( "/,/", ",.phpinfodisplay ", $i );'
		                ),
		            preg_split( '/\n/', trim(preg_replace( "/\nbody/", "\n", $matches[1])) )
		            )
		        ),
		    "</style>\n",
		    $matches[2],
		    "\n</div>\n";

		print "<br/>\n";
	}
}	
  	
?>