<?php
//
// Part of the WP Tuner Plugin, Copyright 2008 ICTA / Mr Pete
//
// This subclasses wpdb, with replacement get_caller()
// Used for 2.3.2 and after

class wpdb_wptunerversion extends wpdb {
	function wpdb_wptunerversion() {
		global $wpdb;
		if (isset($wpdb))
		{
			// A bit complicated: we're not properly installed, and $wpdb already exists. so,
			// we need to replicate it! Otherwise WP will die a horrible death...
			$oldVars = get_object_vars($wpdb);
			foreach ($oldVars as $key => $val)
			{
				$this->{$key} = $val;
			}
		}
	}
	
	
	
	/**
	 * Get the name of the function that called wpdb.
	 * @return string: file, linenumber and name of the calling function
	 * 
	 * This version actually provides helpful info. The original simply says things like 'require_once'
	 */
	function get_caller() {
		global $wptunershow;
		
		// requires PHP 4.3+
		if ( !is_callable('debug_backtrace') )
			return '';
		$bt = debug_backtrace();
		$caller = '';
		//echo '<pre>'.print_r($bt,TRUE).'</pre>';
		
//
// Scan for the first non-wpdb location on the stack
//
		foreach ( $bt as $idx => $trace ) {
			if (isset($trace['class'])) {
				switch ($trace['class']) {
					case __CLASS__: 
					case 'wpdb':		
					$caller.='class]';
					continue 2; // continue the foreach
				}
			}

			$parse=substr($trace['file'],strlen(ABSPATH),11);
			if (substr($parse,0,10) == 'wp-content') 
			{
				break; // we found a plugin or theme, so stop here
			}			
			if (isset($wptunershow) && $wptunershow->bChargePlugins && $parse == 'wp-includes') {
				continue; // all include-functions get charged to the calling plugin!
			}
				
			break;
		}
		
		if ($idx && !strlen($bt[$idx]['file'])) $idx--; // somehow we're in a black hole. Charge to whatever this one called
		$trace = $bt[$idx];
		$trace['file'] = substr($trace['file'],strlen(ABSPATH));
		$caller = $trace['file']."({$trace['line']})->{$trace['function']}()";
		return $caller;
	}
}
?>